# seroapi
Muiltidomain static site hosting

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.2.7
- Package version: 0.2.7
- Generator version: 7.7.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import seroapi
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import seroapi
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import seroapi
from seroapi.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = seroapi.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with seroapi.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = seroapi.AccountManagementApi(api_client)
    login_request = seroapi.LoginRequest() # LoginRequest | 

    try:
        # Login user and receive JWT token.
        api_response = api_instance.login(login_request)
        print("The response of AccountManagementApi->login:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AccountManagementApi->login: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountManagementApi* | [**login**](docs/AccountManagementApi.md#login) | **POST** /api/auth/login | Login user and receive JWT token.
*AccountManagementApi* | [**registration**](docs/AccountManagementApi.md#registration) | **POST** /api/auth/registration | Register new user for sero server.
*ActionsApi* | [**disable_site**](docs/ActionsApi.md#disable_site) | **PATCH** /api/site/disable | Disables a specific site identified by the &#x60;x-subdomain&#x60; header.
*ActionsApi* | [**download_site**](docs/ActionsApi.md#download_site) | **GET** /api/site | Download site of the specified subdomain.
*ActionsApi* | [**enable_site**](docs/ActionsApi.md#enable_site) | **PATCH** /api/site/enable | Enables a specific site identified by the &#x60;x-subdomain&#x60; header.
*ActionsApi* | [**teardown_site**](docs/ActionsApi.md#teardown_site) | **DELETE** /api/site | Removes a specific site identified by the &#x60;x-subdomain&#x60; header.
*ActionsApi* | [**upload_site**](docs/ActionsApi.md#upload_site) | **POST** /api/site | Uploads site for a specified subdomain.
*OriginsManagementAndDynamicAccessControlApi* | [**create_origin**](docs/OriginsManagementAndDynamicAccessControlApi.md#create_origin) | **POST** /api/origin | Adds a new origin to a specified subdomain for dynamic CORS (Cross-Origin Resource Sharing) management.
*OriginsManagementAndDynamicAccessControlApi* | [**delete_all_origins**](docs/OriginsManagementAndDynamicAccessControlApi.md#delete_all_origins) | **DELETE** /api/origin | Delete all origins for specified subdomain for dynamic CORS (Cross-Origin Resource Sharing) management.
*OriginsManagementAndDynamicAccessControlApi* | [**delete_origin_by_id**](docs/OriginsManagementAndDynamicAccessControlApi.md#delete_origin_by_id) | **DELETE** /api/origin/{id} | Delete origin by id for specified subdomain for dynamic CORS (Cross-Origin Resource Sharing) management.
*OriginsManagementAndDynamicAccessControlApi* | [**get_all_origins**](docs/OriginsManagementAndDynamicAccessControlApi.md#get_all_origins) | **GET** /api/origin | List all origins for specified subdomain for dynamic CORS (Cross-Origin Resource Sharing) management.
*OriginsManagementAndDynamicAccessControlApi* | [**get_origin_by_id**](docs/OriginsManagementAndDynamicAccessControlApi.md#get_origin_by_id) | **GET** /api/origin/{id} | Get specified origin [by id] for specified subdomain for dynamic CORS (Cross-Origin Resource Sharing) management.


## Documentation For Models

 - [AddOriginRequest](docs/AddOriginRequest.md)
 - [AddOriginResponse](docs/AddOriginResponse.md)
 - [Details](docs/Details.md)
 - [GetOriginResponse](docs/GetOriginResponse.md)
 - [ListOriginsResponse](docs/ListOriginsResponse.md)
 - [LoginRequest](docs/LoginRequest.md)
 - [LoginResponse](docs/LoginResponse.md)
 - [OriginModel](docs/OriginModel.md)
 - [RegistrationRequest](docs/RegistrationRequest.md)
 - [RegistrationResponse](docs/RegistrationResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="Bearer-JWT"></a>
### Bearer-JWT

- **Type**: Bearer authentication (JWT)


## Author

clowzed.work@gmail.com


